Skip to main content

Request

Whenever the page sends a request for a network resource the following sequence of events are emitted by Page:

If request fails at some point, then instead of 'requestfinished' event (and possibly instead of 'response' event), the page.on("requestfailed") event is emitted.

note

HTTP Error responses, such as 404 or 503, are still successful responses from HTTP standpoint, so request will complete with 'requestfinished' event.

If request gets a 'redirect' response, the request is successfully finished with the requestfinished event, and a new request is issued to a redirected url.


Methods​

all_headers​

Added in: v1.15 request.all_headers

An object with all the request HTTP headers associated with this request. The header names are lower-cased.

Usage

request.all_headers()

Returns


header_value​

Added in: v1.15 request.header_value

Returns the value of the header matching the name. The name is case-insensitive.

Usage

request.header_value(name)

Arguments

  • name str#

    Name of the header.

Returns


headers_array​

Added in: v1.15 request.headers_array

An array with all the request HTTP headers associated with this request. Unlike request.all_headers(), header names are NOT lower-cased. Headers with multiple entries, such as Set-Cookie, appear in the array multiple times.

Usage

request.headers_array()

Returns


response​

Added before v1.9 request.response

Returns the matching Response object, or null if the response was not received due to error.

Usage

request.response()

Returns


sizes​

Added in: v1.15 request.sizes

Returns resource size information for given request.

Usage

request.sizes()

Returns

  • Dict#
    • requestBodySize int

      Size of the request body (POST data payload) in bytes. Set to 0 if there was no body.

    • requestHeadersSize int

      Total number of bytes from the start of the HTTP request message until (and including) the double CRLF before the body.

    • responseBodySize int

      Size of the received response body (encoded) in bytes.

    • responseHeadersSize int

      Total number of bytes from the start of the HTTP response message until (and including) the double CRLF before the body.


Properties​

existing_response​

Added in: v1.59 request.existing_response

Returns the Response object if the response has already been received, null otherwise.

Unlike request.response(), this method does not wait for the response to arrive. It returns immediately with the response object if the response has been received, or null if the response has not been received yet.

Usage

request.existing_response

Returns


failure​

Added before v1.9 request.failure

The method returns null unless this request has failed, as reported by requestfailed event.

Usage

Example of logging of all the failed requests:

page.on("requestfailed", lambda request: print(request.url + " " + request.failure))

Returns


frame​

Added before v1.9 request.frame

Returns the Frame that initiated this request.

Usage

frame_url = request.frame.url

Returns

Details

Note that in some cases the frame is not available, and this method will throw.

  • When request originates in the Service Worker. You can use request.serviceWorker() to check that.
  • When navigation request is issued before the corresponding frame is created. You can use request.is_navigation_request() to check that.

Here is an example that handles all the cases:


headers​

Added before v1.9 request.headers

An object with the request HTTP headers. The header names are lower-cased. Note that this method does not return security-related headers, including cookie-related ones. You can use request.all_headers() for complete list of headers that include cookie information.

Usage

request.headers

Returns


is_navigation_request​

Added before v1.9 request.is_navigation_request

Whether this request is driving frame's navigation.

Some navigation requests are issued before the corresponding frame is created, and therefore do not have request.frame available.

Usage

request.is_navigation_request()

Returns


method​

Added before v1.9 request.method

Request's method (GET, POST, etc.)

Usage

request.method

Returns


post_data​

Added before v1.9 request.post_data

Request's post body, if any.

Usage

request.post_data

Returns


post_data_buffer​